package com.FranckBarbier.Java._Inheritance_and_genericity;

public class Biennal_synthesis {

    private final Activity_card _current_year;
    private final Activity_card _previous_year;
    public final double lambda_for_sygma;
    public final double lambda_for_delta;

    public Biennal_synthesis(final Activity_card current_year, final Activity_card previous_year, final double s, final double d) {
        if (previous_year.year != current_year.year - 1) {
            throw new RuntimeException("OCL invariant violated");
        }
        _current_year = current_year;
        _previous_year = previous_year;
        lambda_for_sygma = s;
        lambda_for_delta = d;
    }

    public double sygma_turnover_indicator_qn() {
        return Math.abs(lambda_for_sygma) * _current_year.turnover_indicator_sygma_qn(_previous_year);
    }

    public double sygma_turnover_indicator_mn() {
        return Math.abs(lambda_for_sygma) * _current_year.turnover_indicator_sygma_mn(_previous_year);
    }

    public double delta_turnover_indicator_qn() {
        return Math.abs(lambda_for_delta) * _current_year.turnover_indicator_delta_qn(_previous_year);
    }

    public double delta_turnover_indicator_mn() {
        return Math.abs(lambda_for_delta) * _current_year.turnover_indicator_delta_mn(_previous_year);
    }
}
