package com.FranckBarbier.Java._Inheritance_and_genericity;

public class Vector_maximum_norm<T extends Number> extends Vector<T> {

    protected Vector<T> create(int s) {
        return new Vector_maximum_norm<T>(s);
    }

    public Vector_maximum_norm(T[] t) {
        super(t);
    }

    public Vector_maximum_norm(int size) {
        super(size);
    }

    public double norm() {
        // T max = java.util.Collections.max(_implementation); // This fails because 'Number' does not implemente 'Comparable<Number>'
        return Math.abs(max());
    }

    public double doubleValue() {
        return norm();
    }

    public float floatValue() {
        return (float) doubleValue();
    }

    public int intValue() {
        return (int) doubleValue();
    }

    public long longValue() {
        return (long) doubleValue();
    }
}
