package com.FranckBarbier.Java._Inheritance_and_genericity;

public class Vector_quadratic_norm<T extends Number> extends Vector<T> {

    protected Vector<T> create(int size) {
        return new Vector_quadratic_norm<T>(size);
    }

    public Vector_quadratic_norm(T[] t) {
        super(t);
    }

    public Vector_quadratic_norm(int size) {
        super(size);
    }

    public double norm() {
        Vector<T> multiplication = this.multiply(this);
        return Math.sqrt(multiplication.accumulate());
    }

    public double doubleValue() {
        return accumulate();
    }

    public float floatValue() {
        return (float) doubleValue();
    }

    public int intValue() {
        return (int) doubleValue();
    }

    public long longValue() {
        return (long) doubleValue();
    }
}
