package com.FranckBarbier.Java._Inheritance_and_genericity;

public class Activity_card {

    public final int client_number;
    public final int year;
    private Vector<Vector<Double>> _implementation;

    public Activity_card(final int client_number, final int year) {
        assert (client_number > 0);
        this.client_number = client_number;
        this.year = year;
//        instead of 'set2008' or 'set2009'
//        _implementation = new Vector_quadratic_norm<Vector<Double>>(12);
//        for (int i = 0; i < 12; i++) {
//            _implementation.set(i, new Vector_quadratic_norm<Double>(client_number));
//        }
    }

    public double turnover_indicator_qn() {
        return _implementation.norm();
    }

    public double turnover_indicator_mn() {
//      compliance with 'set2008' or 'set2009'
        Vector_maximum_norm<Vector<Double>> as_VMN = new Vector_maximum_norm<Vector<Double>>(/*12*/3);
        for (int i = 0; i < /*12*/ 3; i++) {
            Vector_maximum_norm<Double> vmn = new Vector_maximum_norm<Double>(client_number);
            as_VMN.set(i, vmn);
            for (int j = 0; j < client_number; j++) {
                vmn.set(j, ((Vector<Double>) _implementation.get(i)).get(j));
            }
        }
        return as_VMN.norm();
    }

    double turnover_indicator_sygma_qn(final Activity_card activity_card) {
        return (_implementation.plus(activity_card._implementation)).norm();
    }

    double turnover_indicator_delta_qn(final Activity_card activity_card) {
        return (_implementation.minus(activity_card._implementation)).norm();
    }

    double turnover_indicator_sygma_mn(final Activity_card activity_card) {
        return 0.; // to be completed
    }

    double turnover_indicator_delta_mn(final Activity_card activity_card) {
        return 0.; // to be completed
    }

    void set2008() {
        Double t1[] = {3.3, 0., 9.7};
        Double t2[] = {0., 5.6, 6.8};
        Double t3[] = {6.4, 8.4, 2.3};
        Vector<Double> v1 = new Vector_quadratic_norm<Double>(t1);
        Vector<Double> v2 = new Vector_quadratic_norm<Double>(t2);
        Vector<Double> v3 = new Vector_quadratic_norm<Double>(t3);
        _implementation = new Vector_quadratic_norm<Vector<Double>>(3);
        _implementation.set(0, v1);
        _implementation.set(1, v2);
        _implementation.set(2, v3);
    }

    void set2009() {
        Double t1[] = {0.8, 1.4, 2.9};
        Double t2[] = {0., 6.8, 3.5};
        Double t3[] = {2.9, 6.9, 0.};
        Vector<Double> v1 = new Vector_quadratic_norm<Double>(t1);
        Vector<Double> v2 = new Vector_quadratic_norm<Double>(t2);
        Vector<Double> v3 = new Vector_quadratic_norm<Double>(t3);
        _implementation = new Vector_quadratic_norm<Vector<Double>>(3);
        _implementation.set(0, v1);
        _implementation.set(1, v2);
        _implementation.set(2, v3);
    }
}
