package com.FranckBarbier.Java._Inheritance_and_genericity;

public class Inheritance_and_genericity {

    public static void main(String[] args) {
        Double t1[] = {3.3, 0., 9.7};
        Double t2[] = {0., 5.6, 6.8};
        Double t3[] = {6.4, 8.4, 2.3};

        Vector<Double> v1 = new Vector_quadratic_norm<Double>(t1);
        Vector<Double> v2 = new Vector_quadratic_norm<Double>(t2);
        Vector<Double> v3 = new Vector_quadratic_norm<Double>(t3);
        Vector<Vector<Double>> matrix = new Vector_quadratic_norm<Vector<Double>>(3);
        matrix.set(0, v1);
        matrix.set(1, v2);
        matrix.set(2, v3);
        System.out.println(matrix.norm());

        v1 = new Vector_maximum_norm<Double>(t1);
        v2 = new Vector_maximum_norm<Double>(t2);
        v3 = new Vector_maximum_norm<Double>(t3);
        matrix = new Vector_maximum_norm<Vector<Double>>(3);
        matrix.set(0, v1);
        matrix.set(1, v2);
        matrix.set(2, v3);
        System.out.println(matrix.norm());

        Activity_card ac2008 = new Activity_card(3, 2008);
        ac2008.set2008();
        System.out.println(ac2008.year + " (QN): " + ac2008.turnover_indicator_qn());
        System.out.println(ac2008.year + " (MN): " + ac2008.turnover_indicator_mn());
        Activity_card ac2009 = new Activity_card(3, 2009);
        ac2009.set2009();
        System.out.println(ac2009.year + " (QN): " + ac2009.turnover_indicator_qn());
        System.out.println(ac2009.year + " (MN): " + ac2009.turnover_indicator_mn());

        Biennal_synthesis bs = new Biennal_synthesis(ac2009, ac2008, .5, .3);
        System.out.println("2009 + 2008 (sygma-QN): " + bs.sygma_turnover_indicator_qn());
        System.out.println("2009 + 2008 (sygma-MN): " + bs.sygma_turnover_indicator_mn());
        System.out.println("2009 - 2008 (delta-QN): " + bs.delta_turnover_indicator_qn());
        System.out.println("2009 - 2008 (delta-MN): " + bs.delta_turnover_indicator_mn());
    }
}
